Package org.springframework.security.acls.model

# Interface Permission

All Superinterfaces:
  `Serializable`

All Known Implementing Classes:
  `AbstractPermission`, `BasePermission`, `CumulativePermission`

public interface Permission extends Serializable
Represents a permission granted to a `Sid` for a given domain object.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final char`
`RESERVED_OFF`
`static final char`
`RESERVED_ON`
`static final String`
`THIRTY_TWO_RESERVED_OFF`

## Method Summary

Modifier and Type
Method
Description
`int`
`getMask()`
Returns the bits that represents the permission.
`String`
`getPattern()`
Returns a 32-character long bit pattern `String` representing this permission.

## Field Details

### RESERVED_ON

static final char RESERVED_ON

See Also:
  - Constant Field Values

### RESERVED_OFF

static final char RESERVED_OFF

See Also:
  - Constant Field Values

### THIRTY_TWO_RESERVED_OFF

static final String THIRTY_TWO_RESERVED_OFF

See Also:
  - Constant Field Values

## Method Details

### getMask

int getMask()
Returns the bits that represents the permission.

Returns:
  the bits that represent the permission

### getPattern

String getPattern()
Returns a 32-character long bit pattern `String` representing this permission.

Implementations are free to format the pattern as they see fit, although under no circumstances may `RESERVED_OFF` or `RESERVED_ON` be used within the pattern. An exemption is in the case of `RESERVED_OFF` which is used to denote a bit that is off (clear). Implementations may also elect to use `RESERVED_ON` internally for computation purposes, although this method may not return any `String` containing `RESERVED_ON`.

The returned String must be 32 characters in length.

This method is only used for user interface and logging purposes. It is not used in any permission calculations. Therefore, duplication of characters within the output is permitted.

Returns:
  a 32-character bit pattern